library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity flag is 

    Port ( 
		 FLA : in std_logic_vector(5 downto 1);
		 FLB : in std_logic_vector(5 downto 1);
		 FLC : in std_logic_vector(5 downto 1);
		 FLD : in std_logic_vector(5 downto 1);
		 FLE : in std_logic_vector(5 downto 1);
		 FLF : in std_logic_vector(5 downto 1);
		 FLG : in std_logic_vector(5 downto 1);
		 FLH : in std_logic_vector(5 downto 1);
		 FLI : in std_logic_vector(5 downto 1);
		 FLJ : in std_logic_vector(5 downto 1);
		 FLK : in std_logic_vector(5 downto 1);
		 FLL : in std_logic_vector(5 downto 1);
		 FLM : in std_logic_vector(5 downto 1);
		 FLN : in std_logic_vector(5 downto 1);
		 FLP : in std_logic_vector(5 downto 1);
		 FLQ : in std_logic_vector(5 downto 1);
		 FLR : in std_logic_vector(5 downto 1);
		 FLS : in std_logic_vector(5 downto 1);

 		 OUTA : out std_logic_vector(5 downto 1);
		 OUTB : out std_logic_vector(5 downto 1);
		 OUTC : out std_logic_vector(5 downto 1);
		 OUTD : out std_logic_vector(5 downto 1);
		 OUTE : out std_logic_vector(5 downto 1);
		 OUTF : out std_logic_vector(5 downto 1);
		 OUTG : out std_logic_vector(5 downto 1);
		 OUTH : out std_logic_vector(5 downto 1);
		 OUTI : out std_logic_vector(5 downto 1);
		 OUTJ : out std_logic_vector(5 downto 1);
		 OUTK : out std_logic_vector(5 downto 1);
		 OUTL : out std_logic_vector(5 downto 1);
		 OUTM : out std_logic_vector(5 downto 1);
		 OUTN : out std_logic_vector(5 downto 1);
		 OUTP : out std_logic_vector(5 downto 1);
		 OUTQ : out std_logic_vector(5 downto 1);
		 OUTR : out std_logic_vector(5 downto 1);
		 OUTS : out std_logic_vector(5 downto 1));

end flag;

architecture ARC  of flag is

BEGIN

OUTA(1) <= FLA(1) AND FLA(5);
OUTA(2) <= FLA(2) AND FLA(5);
OUTA(3) <= FLA(3) AND FLA(5);
OUTA(4) <= FLA(4) AND FLA(5);
OUTA(5) <= FLA(5);

OUTB(1) <= FLB(1) AND FLB(5);
OUTB(2) <= FLB(2) AND FLB(5);
OUTB(3) <= FLB(3) AND FLB(5);
OUTB(4) <= FLB(4) AND FLB(5);
OUTB(5) <= FLB(5);

OUTC(1) <= FLC(1) AND FLC(5);
OUTC(2) <= FLC(2) AND FLC(5);
OUTC(3) <= FLC(3) AND FLC(5);
OUTC(4) <= FLC(4) AND FLC(5);
OUTC(5) <= FLC(5);

OUTD(1) <= FLD(1) AND FLD(5);
OUTD(2) <= FLD(2) AND FLD(5);
OUTD(3) <= FLD(3) AND FLD(5);
OUTD(4) <= FLD(4) AND FLD(5);
OUTD(5) <= FLD(5);

OUTE(1) <= FLE(1) AND FLE(5);
OUTE(2) <= FLE(2) AND FLE(5);
OUTE(3) <= FLE(3) AND FLE(5);
OUTE(4) <= FLE(4) AND FLE(5);
OUTE(5) <= FLE(5);

OUTF(1) <= FLF(1) AND FLF(5);
OUTF(2) <= FLF(2) AND FLF(5);
OUTF(3) <= FLF(3) AND FLF(5);
OUTF(4) <= FLF(4) AND FLF(5);
OUTF(5) <= FLF(5);

OUTG(1) <= FLG(1) AND FLG(5);
OUTG(2) <= FLG(2) AND FLG(5);
OUTG(3) <= FLG(3) AND FLG(5);
OUTG(4) <= FLG(4) AND FLG(5);
OUTG(5) <= FLG(5);

OUTH(1) <= FLH(1) AND FLH(5);
OUTH(2) <= FLH(2) AND FLH(5);
OUTH(3) <= FLH(3) AND FLH(5);
OUTH(4) <= FLH(4) AND FLH(5);
OUTH(5) <= FLH(5);

OUTI(1) <= FLI(1) AND FLI(5);
OUTI(2) <= FLI(2) AND FLI(5);
OUTI(3) <= FLI(3) AND FLI(5);
OUTI(4) <= FLI(4) AND FLI(5);
OUTI(5) <= FLI(5);

OUTJ(1) <= FLJ(1) AND FLJ(5);
OUTJ(2) <= FLJ(2) AND FLJ(5);
OUTJ(3) <= FLJ(3) AND FLJ(5);
OUTJ(4) <= FLJ(4) AND FLJ(5);
OUTJ(5) <= FLJ(5);

OUTK(1) <= FLK(1) AND FLK(5);
OUTK(2) <= FLK(2) AND FLK(5);
OUTK(3) <= FLK(3) AND FLK(5);
OUTK(4) <= FLK(4) AND FLK(5);
OUTK(5) <= FLK(5);

OUTL(1) <= FLL(1) AND FLL(5);
OUTL(2) <= FLL(2) AND FLL(5);
OUTL(3) <= FLL(3) AND FLL(5);
OUTL(4) <= FLL(4) AND FLL(5);
OUTL(5) <= FLL(5);

OUTM(1) <= FLM(1) AND FLM(5);
OUTM(2) <= FLM(2) AND FLM(5);
OUTM(3) <= FLM(3) AND FLM(5);
OUTM(4) <= FLM(4) AND FLM(5);
OUTM(5) <= FLM(5);

OUTN(1) <= FLN(1) AND FLN(5);
OUTN(2) <= FLN(2) AND FLN(5);
OUTN(3) <= FLN(3) AND FLN(5);
OUTN(4) <= FLN(4) AND FLN(5);
OUTN(5) <= FLN(5);

OUTP(1) <= FLP(1) AND FLP(5);
OUTP(2) <= FLP(2) AND FLP(5);
OUTP(3) <= FLP(3) AND FLP(5);
OUTP(4) <= FLP(4) AND FLP(5);
OUTP(5) <= FLP(5);

OUTQ(1) <= FLQ(1) AND FLQ(5);
OUTQ(2) <= FLQ(2) AND FLQ(5);
OUTQ(3) <= FLQ(3) AND FLQ(5);
OUTQ(4) <= FLQ(4) AND FLQ(5);
OUTQ(5) <= FLQ(5);

OUTR(1) <= FLR(1) AND FLR(5);
OUTR(2) <= FLR(2) AND FLR(5);
OUTR(3) <= FLR(3) AND FLR(5);
OUTR(4) <= FLR(4) AND FLR(5);
OUTR(5) <= FLR(5);

OUTS(1) <= FLS(1) AND FLS(5);
OUTS(2) <= FLS(2) AND FLS(5);
OUTS(3) <= FLS(3) AND FLS(5);
OUTS(4) <= FLS(4) AND FLS(5);
OUTS(5) <= FLS(5);

end ARC;
