library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity IODELAY16 is
    Port ( INA : in std_logic_vector(15 downto 0);
           CLK1: in std_logic;
           OUTA : out std_logic_vector(15 downto 0));
end IODELAY16;

architecture structural  of IODELAY16 is

component IODELAY

generic (

DELAY_SRC : string := "O";
IDELAY_TYPE : string := "FIXED";
IDELAY_VALUE : integer := 0;
ODELAY_VALUE : integer := 40;
REFCLK_FREQUENCY : integer := 200);

port ( 
ODATAIN : in std_logic;
DATAOUT : out std_logic;
IDATAIN : in std_logic;
DATAIN : in std_logic;
C : in std_logic;
CE : in std_logic;
INC : in std_logic;
RST : in std_logic;
T : in std_logic);

end component;

BEGIN

U1: IODELAY
PORT MAP (IDATAIN => '0', ODATAIN => INA(0), C => CLK1, DATAOUT => OUTA(0),
DATAIN => '0', CE => '0', RST => '0', T => '0', INC => '0');

U2: IODELAY
PORT MAP (IDATAIN => '0', ODATAIN => INA(1), C => CLK1, DATAOUT => OUTA(1),
DATAIN => '0', CE => '0', RST => '0', T => '0', INC => '0');

U3: IODELAY
PORT MAP (IDATAIN => '0', ODATAIN => INA(2), C => CLK1, DATAOUT => OUTA(2),
DATAIN => '0', CE => '0', RST => '0', T => '0', INC => '0');

U4: IODELAY
PORT MAP (IDATAIN => '0', ODATAIN => INA(3), C => CLK1, DATAOUT => OUTA(3),
DATAIN => '0', CE => '0', RST => '0', T => '0', INC => '0');

U5: IODELAY
PORT MAP (IDATAIN => '0', ODATAIN => INA(4), C => CLK1, DATAOUT => OUTA(4),
DATAIN => '0', CE => '0', RST => '0', T => '0', INC => '0');

U6: IODELAY
PORT MAP (IDATAIN => '0', ODATAIN => INA(5), C => CLK1, DATAOUT => OUTA(5),
DATAIN => '0', CE => '0', RST => '0', T => '0', INC => '0');

U7: IODELAY
PORT MAP (IDATAIN => '0', ODATAIN => INA(6), C => CLK1, DATAOUT => OUTA(6),
DATAIN => '0', CE => '0', RST => '0', T => '0', INC => '0');

U8: IODELAY
PORT MAP (IDATAIN => '0', ODATAIN => INA(7), C => CLK1, DATAOUT => OUTA(7),
DATAIN => '0', CE => '0', RST => '0', T => '0', INC => '0');

U9: IODELAY
PORT MAP (IDATAIN => '0', ODATAIN => INA(8), C => CLK1, DATAOUT => OUTA(8),
DATAIN => '0', CE => '0', RST => '0', T => '0', INC => '0');

U10: IODELAY
PORT MAP (IDATAIN => '0', ODATAIN => INA(9), C => CLK1, DATAOUT => OUTA(9),
DATAIN => '0', CE => '0', RST => '0', T => '0', INC => '0');

U11: IODELAY
PORT MAP (IDATAIN => '0', ODATAIN => INA(10), C => CLK1, DATAOUT => OUTA(10),
DATAIN => '0', CE => '0', RST => '0', T => '0', INC => '0');

U12: IODELAY
PORT MAP (IDATAIN => '0', ODATAIN => INA(11), C => CLK1, DATAOUT => OUTA(11),
DATAIN => '0', CE => '0', RST => '0', T => '0', INC => '0');

U13: IODELAY
PORT MAP (IDATAIN => '0', ODATAIN => INA(12), C => CLK1, DATAOUT => OUTA(12),
DATAIN => '0', CE => '0', RST => '0', T => '0', INC => '0');

U14: IODELAY
PORT MAP (IDATAIN => '0', ODATAIN => INA(13), C => CLK1, DATAOUT => OUTA(13),
DATAIN => '0', CE => '0', RST => '0', T => '0', INC => '0');

U15: IODELAY
PORT MAP (IDATAIN => '0', ODATAIN => INA(14), C => CLK1, DATAOUT => OUTA(14),
DATAIN => '0', CE => '0', RST => '0', T => '0', INC => '0');

U16: IODELAY
PORT MAP (IDATAIN => '0', ODATAIN => INA(15), C => CLK1, DATAOUT => OUTA(15),
DATAIN => '0', CE => '0', RST => '0', T => '0', INC => '0');

END STRUCTURAL;





