module mpcx_tx
(
	input [7:0] tmb1_lct0_hs,
	input [6:0] tmb1_lct0_wg,
	input [3:0] tmb1_lct0_qual,
	input [3:0] tmb1_lct0_cpat,
	input       tmb1_lct0_lr,
	input       tmb1_lct0_vpf,
	input       tmb1_lct0_bc0,
	input       tmb1_lct0_bx0,
	input       tmb1_lct0_syer,
	input [3:0] tmb1_lct0_cscid,

	input [7:0] tmb1_lct1_hs,
	input [6:0] tmb1_lct1_wg,
	input [3:0] tmb1_lct1_qual,
	input [3:0] tmb1_lct1_cpat,
	input       tmb1_lct1_lr,
	input       tmb1_lct1_vpf,
	input       tmb1_lct1_bc0,
	input       tmb1_lct1_bx0,
	input       tmb1_lct1_syer,
	input [3:0] tmb1_lct1_cscid,

	input [7:0] tmb2_lct0_hs,
	input [6:0] tmb2_lct0_wg,
	input [3:0] tmb2_lct0_qual,
	input [3:0] tmb2_lct0_cpat,
	input       tmb2_lct0_lr,
	input       tmb2_lct0_vpf,
	input       tmb2_lct0_bc0,
	input       tmb2_lct0_bx0,
	input       tmb2_lct0_syer,
	input [3:0] tmb2_lct0_cscid,

	input [7:0] tmb2_lct1_hs,
	input [6:0] tmb2_lct1_wg,
	input [3:0] tmb2_lct1_qual,
	input [3:0] tmb2_lct1_cpat,
	input       tmb2_lct1_lr,
	input       tmb2_lct1_vpf,
	input       tmb2_lct1_bc0,
	input       tmb2_lct1_bx0,
	input       tmb2_lct1_syer,
	input [3:0] tmb2_lct1_cscid,

	input [7:0] tmb3_lct0_hs,
	input [6:0] tmb3_lct0_wg,
	input [3:0] tmb3_lct0_qual,
	input [3:0] tmb3_lct0_cpat,
	input       tmb3_lct0_lr,
	input       tmb3_lct0_vpf,
	input       tmb3_lct0_bc0,
	input       tmb3_lct0_bx0,
	input       tmb3_lct0_syer,
	input [3:0] tmb3_lct0_cscid,

	input [7:0] tmb3_lct1_hs,
	input [6:0] tmb3_lct1_wg,
	input [3:0] tmb3_lct1_qual,
	input [3:0] tmb3_lct1_cpat,
	input       tmb3_lct1_lr,
	input       tmb3_lct1_vpf,
	input       tmb3_lct1_bc0,
	input       tmb3_lct1_bx0,
	input       tmb3_lct1_syer,
	input [3:0] tmb3_lct1_cscid,

	input [7:0] tmb4_lct0_hs,
	input [6:0] tmb4_lct0_wg,
	input [3:0] tmb4_lct0_qual,
	input [3:0] tmb4_lct0_cpat,
	input       tmb4_lct0_lr,
	input       tmb4_lct0_vpf,
	input       tmb4_lct0_bc0,
	input       tmb4_lct0_bx0,
	input       tmb4_lct0_syer,
	input [3:0] tmb4_lct0_cscid,

	input [7:0] tmb4_lct1_hs,
	input [6:0] tmb4_lct1_wg,
	input [3:0] tmb4_lct1_qual,
	input [3:0] tmb4_lct1_cpat,
	input       tmb4_lct1_lr,
	input       tmb4_lct1_vpf,
	input       tmb4_lct1_bc0,
	input       tmb4_lct1_bx0,
	input       tmb4_lct1_syer,
	input [3:0] tmb4_lct1_cscid,

	input [7:0] tmb5_lct0_hs,
	input [6:0] tmb5_lct0_wg,
	input [3:0] tmb5_lct0_qual,
	input [3:0] tmb5_lct0_cpat,
	input       tmb5_lct0_lr,
	input       tmb5_lct0_vpf,
	input       tmb5_lct0_bc0,
	input       tmb5_lct0_bx0,
	input       tmb5_lct0_syer,
	input [3:0] tmb5_lct0_cscid,

	input [7:0] tmb5_lct1_hs,
	input [6:0] tmb5_lct1_wg,
	input [3:0] tmb5_lct1_qual,
	input [3:0] tmb5_lct1_cpat,
	input       tmb5_lct1_lr,
	input       tmb5_lct1_vpf,
	input       tmb5_lct1_bc0,
	input       tmb5_lct1_bx0,
	input       tmb5_lct1_syer,
	input [3:0] tmb5_lct1_cscid,

	input [7:0] tmb6_lct0_hs,
	input [6:0] tmb6_lct0_wg,
	input [3:0] tmb6_lct0_qual,
	input [3:0] tmb6_lct0_cpat,
	input       tmb6_lct0_lr,
	input       tmb6_lct0_vpf,
	input       tmb6_lct0_bc0,
	input       tmb6_lct0_bx0,
	input       tmb6_lct0_syer,
	input [3:0] tmb6_lct0_cscid,

	input [7:0] tmb6_lct1_hs,
	input [6:0] tmb6_lct1_wg,
	input [3:0] tmb6_lct1_qual,
	input [3:0] tmb6_lct1_cpat,
	input       tmb6_lct1_lr,
	input       tmb6_lct1_vpf,
	input       tmb6_lct1_bc0,
	input       tmb6_lct1_bx0,
	input       tmb6_lct1_syer,
	input [3:0] tmb6_lct1_cscid,

	input [7:0] tmb7_lct0_hs,
	input [6:0] tmb7_lct0_wg,
	input [3:0] tmb7_lct0_qual,
	input [3:0] tmb7_lct0_cpat,
	input       tmb7_lct0_lr,
	input       tmb7_lct0_vpf,
	input       tmb7_lct0_bc0,
	input       tmb7_lct0_bx0,
	input       tmb7_lct0_syer,
	input [3:0] tmb7_lct0_cscid,

	input [7:0] tmb7_lct1_hs,
	input [6:0] tmb7_lct1_wg,
	input [3:0] tmb7_lct1_qual,
	input [3:0] tmb7_lct1_cpat,
	input       tmb7_lct1_lr,
	input       tmb7_lct1_vpf,
	input       tmb7_lct1_bc0,
	input       tmb7_lct1_bx0,
	input       tmb7_lct1_syer,
	input [3:0] tmb7_lct1_cscid,

	input [7:0] tmb8_lct0_hs,
	input [6:0] tmb8_lct0_wg,
	input [3:0] tmb8_lct0_qual,
	input [3:0] tmb8_lct0_cpat,
	input       tmb8_lct0_lr,
	input       tmb8_lct0_vpf,
	input       tmb8_lct0_bc0,
	input       tmb8_lct0_bx0,
	input       tmb8_lct0_syer,
	input [3:0] tmb8_lct0_cscid,

	input [7:0] tmb8_lct1_hs,
	input [6:0] tmb8_lct1_wg,
	input [3:0] tmb8_lct1_qual,
	input [3:0] tmb8_lct1_cpat,
	input       tmb8_lct1_lr,
	input       tmb8_lct1_vpf,
	input       tmb8_lct1_bc0,
	input       tmb8_lct1_bx0,
	input       tmb8_lct1_syer,
	input [3:0] tmb8_lct1_cscid,

	input [7:0] tmb9_lct0_hs,
	input [6:0] tmb9_lct0_wg,
	input [3:0] tmb9_lct0_qual,
	input [3:0] tmb9_lct0_cpat,
	input       tmb9_lct0_lr,
	input       tmb9_lct0_vpf,
	input       tmb9_lct0_bc0,
	input       tmb9_lct0_bx0,
	input       tmb9_lct0_syer,
	input [3:0] tmb9_lct0_cscid,

	input [7:0] tmb9_lct1_hs,
	input [6:0] tmb9_lct1_wg,
	input [3:0] tmb9_lct1_qual,
	input [3:0] tmb9_lct1_cpat,
	input       tmb9_lct1_lr,
	input       tmb9_lct1_vpf,
	input       tmb9_lct1_bc0,
	input       tmb9_lct1_bx0,
	input       tmb9_lct1_syer,
	input [3:0] tmb9_lct1_cscid,

	input [5:0] mpc_id,
	input enp_vme,

    input rst,
	 input clk40,

    output [39:0] tx_data_gtp_0,
    output [39:0] tx_data_gtp_1,
    output [39:0] tx_data_gtp_2,
    output [39:0] tx_data_gtp_3,
    output [39:0] tx_data_gtp_4,
    output [39:0] tx_data_gtp_5,
    output [39:0] tx_data_gtp_6,
    output [39:0] tx_data_gtp_7,
	 input tx_clk
);

	wire enp = enp_vio | enp_vme; // test pattern can be enabled from VIO or VME
	wire [75:0] link_tx_data [7:0];
	
    (* mark_debug *) wire [37:0] tx_data_38_s [7:0], tx_data_38 [7:0];
    (* mark_debug *) wire [7:0] frame_0;
    reg  [1:0] tx_header [7:0];
    (* mark_debug *) wire [1:0] tx_header_0 = tx_header[0];
    (* mark_debug *) wire [1:0] tx_header_1 = tx_header[1];
    (* mark_debug *) wire [1:0] tx_header_2 = tx_header[2];
    (* mark_debug *) wire [1:0] tx_header_3 = tx_header[3];
    (* mark_debug *) wire [1:0] tx_header_4 = tx_header[4];
    (* mark_debug *) wire [1:0] tx_header_5 = tx_header[5];
    (* mark_debug *) wire [1:0] tx_header_6 = tx_header[6];
    (* mark_debug *) wire [1:0] tx_header_7 = tx_header[7];
    reg [5:0] tx_header_cnt [7:0];


    // transmit frame_0 marker only once per 64 BX, to prevent unlocking frame alignment in RX
    // count frame_0 markers
	 integer i;
    always @(posedge tx_clk) 
	 begin
		for (i = 0; i < 8; i=i+1)
		begin
			tx_header[i] = 
           (rst == 1'b1) ? 2'b00 : // this is for header alignment tests on rx side 
           (frame_0[i] == 1'b0 && tx_header_cnt[i] == 6'h0) ? 2'b10 : // frame_0 header
           2'b01; // regular header
			
			if (frame_0[i] == 1'b1) tx_header_cnt[i] = tx_header_cnt[i] + 6'b1;
		end
	 end
	 
	 reg [11:0] bxc;
	 always @(posedge clk40) 
	 begin
		if (bxc == 12'd3563) bxc = 12'h0;
		else bxc = bxc + 12'b1; // just free-running BX counter
	 end
	 
 	 assign tx_data_gtp_0 = {tx_header[0], tx_data_38_s[0]};
 	 assign tx_data_gtp_1 = {tx_header[1], tx_data_38_s[1]};
 	 assign tx_data_gtp_2 = {tx_header[2], tx_data_38_s[2]};
 	 assign tx_data_gtp_3 = {tx_header[3], tx_data_38_s[3]};
 	 assign tx_data_gtp_4 = {tx_header[4], tx_data_38_s[4]};
 	 assign tx_data_gtp_5 = {tx_header[5], tx_data_38_s[5]};
 	 assign tx_data_gtp_6 = {tx_header[6], tx_data_38_s[6]};
 	 assign tx_data_gtp_7 = {tx_header[7], tx_data_38_s[7]};

	 genvar gi, gj;
	 generate
	 for (gi = 0; gi < 8; gi=gi+1)
	 begin: link_loop


		 mpc_scrambler mpc_s 
		 (
			  .dtx (tx_data_38[gi]), // TX data to scramble
			  .stx (tx_data_38_s[gi]), // scrambled TX data
			  .clk (tx_clk),
			  .rst (1'b0)
		 );
		 
		 tx_reclock txr
		 (
			  .din     (link_tx_data [gi]),
			  .clk40   (clk40), 
			  .dout    (tx_data_38[gi]),
			  .frame_0 (frame_0[gi]),
			  .clk80   (tx_clk)
		 );
	 end
	 endgenerate

	(* mark_debug *) reg [7:0] hs    [9:1][1:0]; // [tmb][lct]
	(* mark_debug *) reg [6:0] wg    [9:1][1:0];
	(* mark_debug *) reg [3:0] qual  [9:1][1:0];
	(* mark_debug *) reg [3:0] cpat  [9:1][1:0];
	(* mark_debug *) reg       lr    [9:1][1:0];
	(* mark_debug *) reg       vpf   [9:1][1:0];
	(* mark_debug *) reg       bc0   [9:1][1:0];
	(* mark_debug *) reg       bx0   [9:1][1:0];
	(* mark_debug *) reg       syer  [9:1][1:0];
	(* mark_debug *) reg [3:0] cscid [9:1][1:0];

	always @(*)
	begin

		hs    [1][0] = (enp == 1'b0) ? tmb1_lct0_hs     : bxc[7:0];
		wg    [1][0] = (enp == 1'b0) ? tmb1_lct0_wg     : bxc[6:0];
		qual  [1][0] = (enp == 1'b0) ? tmb1_lct0_qual   : bxc[3:0];
		cpat  [1][0] = (enp == 1'b0) ? tmb1_lct0_cpat   : bxc[3:0];
		lr    [1][0] = (enp == 1'b0) ? tmb1_lct0_lr     : bxc[0];
		vpf   [1][0] = (enp == 1'b0) ? tmb1_lct0_vpf    : bxc[0];
		bc0   [1][0] = (enp == 1'b0) ? tmb1_lct0_bc0    : (bxc == 12'd3563);
		bx0   [1][0] = (enp == 1'b0) ? tmb1_lct0_bx0    : bxc[1];
		syer  [1][0] = (enp == 1'b0) ? tmb1_lct0_syer   : 0;
		cscid [1][0] = (enp == 1'b0) ? tmb1_lct0_cscid  : 1;
		hs    [1][1] = (enp == 1'b0) ? tmb1_lct1_hs     : bxc[7:0];
		wg    [1][1] = (enp == 1'b0) ? tmb1_lct1_wg     : bxc[6:0];
		qual  [1][1] = (enp == 1'b0) ? tmb1_lct1_qual   : bxc[3:0];
		cpat  [1][1] = (enp == 1'b0) ? tmb1_lct1_cpat   : bxc[3:0];
		lr    [1][1] = (enp == 1'b0) ? tmb1_lct1_lr     : bxc[0];
		vpf   [1][1] = (enp == 1'b0) ? tmb1_lct1_vpf    : ~bxc[0];
		bc0   [1][1] = (enp == 1'b0) ? tmb1_lct1_bc0    : (bxc == 12'd3563);
		bx0   [1][1] = (enp == 1'b0) ? tmb1_lct1_bx0    : bxc[1];
		syer  [1][1] = (enp == 1'b0) ? tmb1_lct1_syer   : 1;
		cscid [1][1] = (enp == 1'b0) ? tmb1_lct1_cscid  : 1;
		hs    [2][0] = (enp == 1'b0) ? tmb2_lct0_hs     : bxc[7:0];
		wg    [2][0] = (enp == 1'b0) ? tmb2_lct0_wg     : bxc[6:0];
		qual  [2][0] = (enp == 1'b0) ? tmb2_lct0_qual   : bxc[3:0];
		cpat  [2][0] = (enp == 1'b0) ? tmb2_lct0_cpat   : bxc[3:0];
		lr    [2][0] = (enp == 1'b0) ? tmb2_lct0_lr     : bxc[0];
		vpf   [2][0] = (enp == 1'b0) ? tmb2_lct0_vpf    : bxc[0];
		bc0   [2][0] = (enp == 1'b0) ? tmb2_lct0_bc0    : (bxc == 12'd3563);
		bx0   [2][0] = (enp == 1'b0) ? tmb2_lct0_bx0    : bxc[1];
		syer  [2][0] = (enp == 1'b0) ? tmb2_lct0_syer   : 0;
		cscid [2][0] = (enp == 1'b0) ? tmb2_lct0_cscid  : 2;
		hs    [2][1] = (enp == 1'b0) ? tmb2_lct1_hs     : bxc[7:0];
		wg    [2][1] = (enp == 1'b0) ? tmb2_lct1_wg     : bxc[6:0];
		qual  [2][1] = (enp == 1'b0) ? tmb2_lct1_qual   : bxc[3:0];
		cpat  [2][1] = (enp == 1'b0) ? tmb2_lct1_cpat   : bxc[3:0];
		lr    [2][1] = (enp == 1'b0) ? tmb2_lct1_lr     : bxc[0];
		vpf   [2][1] = (enp == 1'b0) ? tmb2_lct1_vpf    : ~bxc[0];
		bc0   [2][1] = (enp == 1'b0) ? tmb2_lct1_bc0    : (bxc == 12'd3563);
		bx0   [2][1] = (enp == 1'b0) ? tmb2_lct1_bx0    : bxc[1];
		syer  [2][1] = (enp == 1'b0) ? tmb2_lct1_syer   : 1;
		cscid [2][1] = (enp == 1'b0) ? tmb2_lct1_cscid  : 2;
		hs    [3][0] = (enp == 1'b0) ? tmb3_lct0_hs     : bxc[7:0];
		wg    [3][0] = (enp == 1'b0) ? tmb3_lct0_wg     : bxc[6:0];
		qual  [3][0] = (enp == 1'b0) ? tmb3_lct0_qual   : bxc[3:0];
		cpat  [3][0] = (enp == 1'b0) ? tmb3_lct0_cpat   : bxc[3:0];
		lr    [3][0] = (enp == 1'b0) ? tmb3_lct0_lr     : bxc[0];
		vpf   [3][0] = (enp == 1'b0) ? tmb3_lct0_vpf    : bxc[0];
		bc0   [3][0] = (enp == 1'b0) ? tmb3_lct0_bc0    : (bxc == 12'd3563);
		bx0   [3][0] = (enp == 1'b0) ? tmb3_lct0_bx0    : bxc[1];
		syer  [3][0] = (enp == 1'b0) ? tmb3_lct0_syer   : 0;
		cscid [3][0] = (enp == 1'b0) ? tmb3_lct0_cscid  : 3;
		hs    [3][1] = (enp == 1'b0) ? tmb3_lct1_hs     : bxc[7:0];
		wg    [3][1] = (enp == 1'b0) ? tmb3_lct1_wg     : bxc[6:0];
		qual  [3][1] = (enp == 1'b0) ? tmb3_lct1_qual   : bxc[3:0];
		cpat  [3][1] = (enp == 1'b0) ? tmb3_lct1_cpat   : bxc[3:0];
		lr    [3][1] = (enp == 1'b0) ? tmb3_lct1_lr     : bxc[0];
		vpf   [3][1] = (enp == 1'b0) ? tmb3_lct1_vpf    : ~bxc[0];
		bc0   [3][1] = (enp == 1'b0) ? tmb3_lct1_bc0    : (bxc == 12'd3563);
		bx0   [3][1] = (enp == 1'b0) ? tmb3_lct1_bx0    : bxc[1];
		syer  [3][1] = (enp == 1'b0) ? tmb3_lct1_syer   : 1;
		cscid [3][1] = (enp == 1'b0) ? tmb3_lct1_cscid  : 3;
		hs    [4][0] = (enp == 1'b0) ? tmb4_lct0_hs     : bxc[7:0];
		wg    [4][0] = (enp == 1'b0) ? tmb4_lct0_wg     : bxc[6:0];
		qual  [4][0] = (enp == 1'b0) ? tmb4_lct0_qual   : bxc[3:0];
		cpat  [4][0] = (enp == 1'b0) ? tmb4_lct0_cpat   : bxc[3:0];
		lr    [4][0] = (enp == 1'b0) ? tmb4_lct0_lr     : bxc[0];
		vpf   [4][0] = (enp == 1'b0) ? tmb4_lct0_vpf    : bxc[0];
		bc0   [4][0] = (enp == 1'b0) ? tmb4_lct0_bc0    : (bxc == 12'd3563);
		bx0   [4][0] = (enp == 1'b0) ? tmb4_lct0_bx0    : bxc[1];
		syer  [4][0] = (enp == 1'b0) ? tmb4_lct0_syer   : 0;
		cscid [4][0] = (enp == 1'b0) ? tmb4_lct0_cscid  : 4;
		hs    [4][1] = (enp == 1'b0) ? tmb4_lct1_hs     : bxc[7:0];
		wg    [4][1] = (enp == 1'b0) ? tmb4_lct1_wg     : bxc[6:0];
		qual  [4][1] = (enp == 1'b0) ? tmb4_lct1_qual   : bxc[3:0];
		cpat  [4][1] = (enp == 1'b0) ? tmb4_lct1_cpat   : bxc[3:0];
		lr    [4][1] = (enp == 1'b0) ? tmb4_lct1_lr     : bxc[0];
		vpf   [4][1] = (enp == 1'b0) ? tmb4_lct1_vpf    : ~bxc[0];
		bc0   [4][1] = (enp == 1'b0) ? tmb4_lct1_bc0    : (bxc == 12'd3563);
		bx0   [4][1] = (enp == 1'b0) ? tmb4_lct1_bx0    : bxc[1];
		syer  [4][1] = (enp == 1'b0) ? tmb4_lct1_syer   : 1;
		cscid [4][1] = (enp == 1'b0) ? tmb4_lct1_cscid  : 4;
		hs    [5][0] = (enp == 1'b0) ? tmb5_lct0_hs     : bxc[7:0];
		wg    [5][0] = (enp == 1'b0) ? tmb5_lct0_wg     : bxc[6:0];
		qual  [5][0] = (enp == 1'b0) ? tmb5_lct0_qual   : bxc[3:0];
		cpat  [5][0] = (enp == 1'b0) ? tmb5_lct0_cpat   : bxc[3:0];
		lr    [5][0] = (enp == 1'b0) ? tmb5_lct0_lr     : bxc[0];
		vpf   [5][0] = (enp == 1'b0) ? tmb5_lct0_vpf    : bxc[0];
		bc0   [5][0] = (enp == 1'b0) ? tmb5_lct0_bc0    : (bxc == 12'd3563);
		bx0   [5][0] = (enp == 1'b0) ? tmb5_lct0_bx0    : bxc[1];
		syer  [5][0] = (enp == 1'b0) ? tmb5_lct0_syer   : 0;
		cscid [5][0] = (enp == 1'b0) ? tmb5_lct0_cscid  : 5;
		hs    [5][1] = (enp == 1'b0) ? tmb5_lct1_hs     : bxc[7:0];
		wg    [5][1] = (enp == 1'b0) ? tmb5_lct1_wg     : bxc[6:0];
		qual  [5][1] = (enp == 1'b0) ? tmb5_lct1_qual   : bxc[3:0];
		cpat  [5][1] = (enp == 1'b0) ? tmb5_lct1_cpat   : bxc[3:0];
		lr    [5][1] = (enp == 1'b0) ? tmb5_lct1_lr     : bxc[0];
		vpf   [5][1] = (enp == 1'b0) ? tmb5_lct1_vpf    : ~bxc[0];
		bc0   [5][1] = (enp == 1'b0) ? tmb5_lct1_bc0    : (bxc == 12'd3563);
		bx0   [5][1] = (enp == 1'b0) ? tmb5_lct1_bx0    : bxc[1];
		syer  [5][1] = (enp == 1'b0) ? tmb5_lct1_syer   : 1;
		cscid [5][1] = (enp == 1'b0) ? tmb5_lct1_cscid  : 5;
		hs    [6][0] = (enp == 1'b0) ? tmb6_lct0_hs     : bxc[7:0];
		wg    [6][0] = (enp == 1'b0) ? tmb6_lct0_wg     : bxc[6:0];
		qual  [6][0] = (enp == 1'b0) ? tmb6_lct0_qual   : bxc[3:0];
		cpat  [6][0] = (enp == 1'b0) ? tmb6_lct0_cpat   : bxc[3:0];
		lr    [6][0] = (enp == 1'b0) ? tmb6_lct0_lr     : bxc[0];
		vpf   [6][0] = (enp == 1'b0) ? tmb6_lct0_vpf    : bxc[0];
		bc0   [6][0] = (enp == 1'b0) ? tmb6_lct0_bc0    : (bxc == 12'd3563);
		bx0   [6][0] = (enp == 1'b0) ? tmb6_lct0_bx0    : bxc[1];
		syer  [6][0] = (enp == 1'b0) ? tmb6_lct0_syer   : 0;
		cscid [6][0] = (enp == 1'b0) ? tmb6_lct0_cscid  : 6;
		hs    [6][1] = (enp == 1'b0) ? tmb6_lct1_hs     : bxc[7:0];
		wg    [6][1] = (enp == 1'b0) ? tmb6_lct1_wg     : bxc[6:0];
		qual  [6][1] = (enp == 1'b0) ? tmb6_lct1_qual   : bxc[3:0];
		cpat  [6][1] = (enp == 1'b0) ? tmb6_lct1_cpat   : bxc[3:0];
		lr    [6][1] = (enp == 1'b0) ? tmb6_lct1_lr     : bxc[0];
		vpf   [6][1] = (enp == 1'b0) ? tmb6_lct1_vpf    : ~bxc[0];
		bc0   [6][1] = (enp == 1'b0) ? tmb6_lct1_bc0    : (bxc == 12'd3563);
		bx0   [6][1] = (enp == 1'b0) ? tmb6_lct1_bx0    : bxc[1];
		syer  [6][1] = (enp == 1'b0) ? tmb6_lct1_syer   : 1;
		cscid [6][1] = (enp == 1'b0) ? tmb6_lct1_cscid  : 6;
		hs    [7][0] = (enp == 1'b0) ? tmb7_lct0_hs     : bxc[7:0];
		wg    [7][0] = (enp == 1'b0) ? tmb7_lct0_wg     : bxc[6:0];
		qual  [7][0] = (enp == 1'b0) ? tmb7_lct0_qual   : bxc[3:0];
		cpat  [7][0] = (enp == 1'b0) ? tmb7_lct0_cpat   : bxc[3:0];
		lr    [7][0] = (enp == 1'b0) ? tmb7_lct0_lr     : bxc[0];
		vpf   [7][0] = (enp == 1'b0) ? tmb7_lct0_vpf    : bxc[0];
		bc0   [7][0] = (enp == 1'b0) ? tmb7_lct0_bc0    : (bxc == 12'd3563);
		bx0   [7][0] = (enp == 1'b0) ? tmb7_lct0_bx0    : bxc[1];
		syer  [7][0] = (enp == 1'b0) ? tmb7_lct0_syer   : 0;
		cscid [7][0] = (enp == 1'b0) ? tmb7_lct0_cscid  : 7;
		hs    [7][1] = (enp == 1'b0) ? tmb7_lct1_hs     : bxc[7:0];
		wg    [7][1] = (enp == 1'b0) ? tmb7_lct1_wg     : bxc[6:0];
		qual  [7][1] = (enp == 1'b0) ? tmb7_lct1_qual   : bxc[3:0];
		cpat  [7][1] = (enp == 1'b0) ? tmb7_lct1_cpat   : bxc[3:0];
		lr    [7][1] = (enp == 1'b0) ? tmb7_lct1_lr     : bxc[0];
		vpf   [7][1] = (enp == 1'b0) ? tmb7_lct1_vpf    : ~bxc[0];
		bc0   [7][1] = (enp == 1'b0) ? tmb7_lct1_bc0    : (bxc == 12'd3563);
		bx0   [7][1] = (enp == 1'b0) ? tmb7_lct1_bx0    : bxc[1];
		syer  [7][1] = (enp == 1'b0) ? tmb7_lct1_syer   : 1;
		cscid [7][1] = (enp == 1'b0) ? tmb7_lct1_cscid  : 7;
		hs    [8][0] = (enp == 1'b0) ? tmb8_lct0_hs     : bxc[7:0];
		wg    [8][0] = (enp == 1'b0) ? tmb8_lct0_wg     : bxc[6:0];
		qual  [8][0] = (enp == 1'b0) ? tmb8_lct0_qual   : bxc[3:0];
		cpat  [8][0] = (enp == 1'b0) ? tmb8_lct0_cpat   : bxc[3:0];
		lr    [8][0] = (enp == 1'b0) ? tmb8_lct0_lr     : bxc[0];
		vpf   [8][0] = (enp == 1'b0) ? tmb8_lct0_vpf    : bxc[0];
		bc0   [8][0] = (enp == 1'b0) ? tmb8_lct0_bc0    : (bxc == 12'd3563);
		bx0   [8][0] = (enp == 1'b0) ? tmb8_lct0_bx0    : bxc[1];
		syer  [8][0] = (enp == 1'b0) ? tmb8_lct0_syer   : 0;
		cscid [8][0] = (enp == 1'b0) ? tmb8_lct0_cscid  : 8;
		hs    [8][1] = (enp == 1'b0) ? tmb8_lct1_hs     : bxc[7:0];
		wg    [8][1] = (enp == 1'b0) ? tmb8_lct1_wg     : bxc[6:0];
		qual  [8][1] = (enp == 1'b0) ? tmb8_lct1_qual   : bxc[3:0];
		cpat  [8][1] = (enp == 1'b0) ? tmb8_lct1_cpat   : bxc[3:0];
		lr    [8][1] = (enp == 1'b0) ? tmb8_lct1_lr     : bxc[0];
		vpf   [8][1] = (enp == 1'b0) ? tmb8_lct1_vpf    : ~bxc[0];
		bc0   [8][1] = (enp == 1'b0) ? tmb8_lct1_bc0    : (bxc == 12'd3563);
		bx0   [8][1] = (enp == 1'b0) ? tmb8_lct1_bx0    : bxc[1];
		syer  [8][1] = (enp == 1'b0) ? tmb8_lct1_syer   : 1;
		cscid [8][1] = (enp == 1'b0) ? tmb8_lct1_cscid  : 8;
		hs    [9][0] = (enp == 1'b0) ? tmb9_lct0_hs     : bxc[7:0];
		wg    [9][0] = (enp == 1'b0) ? tmb9_lct0_wg     : bxc[6:0];
		qual  [9][0] = (enp == 1'b0) ? tmb9_lct0_qual   : bxc[3:0];
		cpat  [9][0] = (enp == 1'b0) ? tmb9_lct0_cpat   : bxc[3:0];
		lr    [9][0] = (enp == 1'b0) ? tmb9_lct0_lr     : bxc[0];
		vpf   [9][0] = (enp == 1'b0) ? tmb9_lct0_vpf    : bxc[0];
		bc0   [9][0] = (enp == 1'b0) ? tmb9_lct0_bc0    : (bxc == 12'd3563);
		bx0   [9][0] = (enp == 1'b0) ? tmb9_lct0_bx0    : bxc[1];
		syer  [9][0] = (enp == 1'b0) ? tmb9_lct0_syer   : 0;
		cscid [9][0] = (enp == 1'b0) ? tmb9_lct0_cscid  : 9;
		hs    [9][1] = (enp == 1'b0) ? tmb9_lct1_hs     : bxc[7:0];
		wg    [9][1] = (enp == 1'b0) ? tmb9_lct1_wg     : bxc[6:0];
		qual  [9][1] = (enp == 1'b0) ? tmb9_lct1_qual   : bxc[3:0];
		cpat  [9][1] = (enp == 1'b0) ? tmb9_lct1_cpat   : bxc[3:0];
		lr    [9][1] = (enp == 1'b0) ? tmb9_lct1_lr     : bxc[0];
		vpf   [9][1] = (enp == 1'b0) ? tmb9_lct1_vpf    : ~bxc[0];
		bc0   [9][1] = (enp == 1'b0) ? tmb9_lct1_bc0    : (bxc == 12'd3563);
		bx0   [9][1] = (enp == 1'b0) ? tmb9_lct1_bx0    : bxc[1];
		syer  [9][1] = (enp == 1'b0) ? tmb9_lct1_syer   : 1;
		cscid [9][1] = (enp == 1'b0) ? tmb9_lct1_cscid  : 9;

	end
        
	mpc_formatter mpcf
	(

		.tmb1_lct0_hs     (hs    [1][0]),
		.tmb1_lct0_wg     (wg    [1][0]),
		.tmb1_lct0_qual   (qual  [1][0]),
		.tmb1_lct0_cpat   (cpat  [1][0]),
		.tmb1_lct0_lr     (lr    [1][0]),
		.tmb1_lct0_vpf    (vpf   [1][0]),
		.tmb1_lct0_bc0    (bc0   [1][0]),
		.tmb1_lct0_bx0    (bx0   [1][0]),
		.tmb1_lct0_syer   (syer  [1][0]),
		.tmb1_lct0_cscid  (cscid [1][0]),
		
		.tmb1_lct1_hs     (hs    [1][1]),
		.tmb1_lct1_wg     (wg    [1][1]),
		.tmb1_lct1_qual   (qual  [1][1]),
		.tmb1_lct1_cpat   (cpat  [1][1]),
		.tmb1_lct1_lr     (lr    [1][1]),
		.tmb1_lct1_vpf    (vpf   [1][1]),
		.tmb1_lct1_bc0    (bc0   [1][1]),
		.tmb1_lct1_bx0    (bx0   [1][1]),
		.tmb1_lct1_syer   (syer  [1][1]),
		.tmb1_lct1_cscid  (cscid [1][1]),
		
		.tmb2_lct0_hs     (hs    [2][0]),
		.tmb2_lct0_wg     (wg    [2][0]),
		.tmb2_lct0_qual   (qual  [2][0]),
		.tmb2_lct0_cpat   (cpat  [2][0]),
		.tmb2_lct0_lr     (lr    [2][0]),
		.tmb2_lct0_vpf    (vpf   [2][0]),
		.tmb2_lct0_bc0    (bc0   [2][0]),
		.tmb2_lct0_bx0    (bx0   [2][0]),
		.tmb2_lct0_syer   (syer  [2][0]),
		.tmb2_lct0_cscid  (cscid [2][0]),
		
		.tmb2_lct1_hs     (hs    [2][1]),
		.tmb2_lct1_wg     (wg    [2][1]),
		.tmb2_lct1_qual   (qual  [2][1]),
		.tmb2_lct1_cpat   (cpat  [2][1]),
		.tmb2_lct1_lr     (lr    [2][1]),
		.tmb2_lct1_vpf    (vpf   [2][1]),
		.tmb2_lct1_bc0    (bc0   [2][1]),
		.tmb2_lct1_bx0    (bx0   [2][1]),
		.tmb2_lct1_syer   (syer  [2][1]),
		.tmb2_lct1_cscid  (cscid [2][1]),
		
		.tmb3_lct0_hs     (hs    [3][0]),
		.tmb3_lct0_wg     (wg    [3][0]),
		.tmb3_lct0_qual   (qual  [3][0]),
		.tmb3_lct0_cpat   (cpat  [3][0]),
		.tmb3_lct0_lr     (lr    [3][0]),
		.tmb3_lct0_vpf    (vpf   [3][0]),
		.tmb3_lct0_bc0    (bc0   [3][0]),
		.tmb3_lct0_bx0    (bx0   [3][0]),
		.tmb3_lct0_syer   (syer  [3][0]),
		.tmb3_lct0_cscid  (cscid [3][0]),
		
		.tmb3_lct1_hs     (hs    [3][1]),
		.tmb3_lct1_wg     (wg    [3][1]),
		.tmb3_lct1_qual   (qual  [3][1]),
		.tmb3_lct1_cpat   (cpat  [3][1]),
		.tmb3_lct1_lr     (lr    [3][1]),
		.tmb3_lct1_vpf    (vpf   [3][1]),
		.tmb3_lct1_bc0    (bc0   [3][1]),
		.tmb3_lct1_bx0    (bx0   [3][1]),
		.tmb3_lct1_syer   (syer  [3][1]),
		.tmb3_lct1_cscid  (cscid [3][1]),
		
		.tmb4_lct0_hs     (hs    [4][0]),
		.tmb4_lct0_wg     (wg    [4][0]),
		.tmb4_lct0_qual   (qual  [4][0]),
		.tmb4_lct0_cpat   (cpat  [4][0]),
		.tmb4_lct0_lr     (lr    [4][0]),
		.tmb4_lct0_vpf    (vpf   [4][0]),
		.tmb4_lct0_bc0    (bc0   [4][0]),
		.tmb4_lct0_bx0    (bx0   [4][0]),
		.tmb4_lct0_syer   (syer  [4][0]),
		.tmb4_lct0_cscid  (cscid [4][0]),
		
		.tmb4_lct1_hs     (hs    [4][1]),
		.tmb4_lct1_wg     (wg    [4][1]),
		.tmb4_lct1_qual   (qual  [4][1]),
		.tmb4_lct1_cpat   (cpat  [4][1]),
		.tmb4_lct1_lr     (lr    [4][1]),
		.tmb4_lct1_vpf    (vpf   [4][1]),
		.tmb4_lct1_bc0    (bc0   [4][1]),
		.tmb4_lct1_bx0    (bx0   [4][1]),
		.tmb4_lct1_syer   (syer  [4][1]),
		.tmb4_lct1_cscid  (cscid [4][1]),
		
		.tmb5_lct0_hs     (hs    [5][0]),
		.tmb5_lct0_wg     (wg    [5][0]),
		.tmb5_lct0_qual   (qual  [5][0]),
		.tmb5_lct0_cpat   (cpat  [5][0]),
		.tmb5_lct0_lr     (lr    [5][0]),
		.tmb5_lct0_vpf    (vpf   [5][0]),
		.tmb5_lct0_bc0    (bc0   [5][0]),
		.tmb5_lct0_bx0    (bx0   [5][0]),
		.tmb5_lct0_syer   (syer  [5][0]),
		.tmb5_lct0_cscid  (cscid [5][0]),
		
		.tmb5_lct1_hs     (hs    [5][1]),
		.tmb5_lct1_wg     (wg    [5][1]),
		.tmb5_lct1_qual   (qual  [5][1]),
		.tmb5_lct1_cpat   (cpat  [5][1]),
		.tmb5_lct1_lr     (lr    [5][1]),
		.tmb5_lct1_vpf    (vpf   [5][1]),
		.tmb5_lct1_bc0    (bc0   [5][1]),
		.tmb5_lct1_bx0    (bx0   [5][1]),
		.tmb5_lct1_syer   (syer  [5][1]),
		.tmb5_lct1_cscid  (cscid [5][1]),
		
		.tmb6_lct0_hs     (hs    [6][0]),
		.tmb6_lct0_wg     (wg    [6][0]),
		.tmb6_lct0_qual   (qual  [6][0]),
		.tmb6_lct0_cpat   (cpat  [6][0]),
		.tmb6_lct0_lr     (lr    [6][0]),
		.tmb6_lct0_vpf    (vpf   [6][0]),
		.tmb6_lct0_bc0    (bc0   [6][0]),
		.tmb6_lct0_bx0    (bx0   [6][0]),
		.tmb6_lct0_syer   (syer  [6][0]),
		.tmb6_lct0_cscid  (cscid [6][0]),
		
		.tmb6_lct1_hs     (hs    [6][1]),
		.tmb6_lct1_wg     (wg    [6][1]),
		.tmb6_lct1_qual   (qual  [6][1]),
		.tmb6_lct1_cpat   (cpat  [6][1]),
		.tmb6_lct1_lr     (lr    [6][1]),
		.tmb6_lct1_vpf    (vpf   [6][1]),
		.tmb6_lct1_bc0    (bc0   [6][1]),
		.tmb6_lct1_bx0    (bx0   [6][1]),
		.tmb6_lct1_syer   (syer  [6][1]),
		.tmb6_lct1_cscid  (cscid [6][1]),
		
		.tmb7_lct0_hs     (hs    [7][0]),
		.tmb7_lct0_wg     (wg    [7][0]),
		.tmb7_lct0_qual   (qual  [7][0]),
		.tmb7_lct0_cpat   (cpat  [7][0]),
		.tmb7_lct0_lr     (lr    [7][0]),
		.tmb7_lct0_vpf    (vpf   [7][0]),
		.tmb7_lct0_bc0    (bc0   [7][0]),
		.tmb7_lct0_bx0    (bx0   [7][0]),
		.tmb7_lct0_syer   (syer  [7][0]),
		.tmb7_lct0_cscid  (cscid [7][0]),
		
		.tmb7_lct1_hs     (hs    [7][1]),
		.tmb7_lct1_wg     (wg    [7][1]),
		.tmb7_lct1_qual   (qual  [7][1]),
		.tmb7_lct1_cpat   (cpat  [7][1]),
		.tmb7_lct1_lr     (lr    [7][1]),
		.tmb7_lct1_vpf    (vpf   [7][1]),
		.tmb7_lct1_bc0    (bc0   [7][1]),
		.tmb7_lct1_bx0    (bx0   [7][1]),
		.tmb7_lct1_syer   (syer  [7][1]),
		.tmb7_lct1_cscid  (cscid [7][1]),
		
		.tmb8_lct0_hs     (hs    [8][0]),
		.tmb8_lct0_wg     (wg    [8][0]),
		.tmb8_lct0_qual   (qual  [8][0]),
		.tmb8_lct0_cpat   (cpat  [8][0]),
		.tmb8_lct0_lr     (lr    [8][0]),
		.tmb8_lct0_vpf    (vpf   [8][0]),
		.tmb8_lct0_bc0    (bc0   [8][0]),
		.tmb8_lct0_bx0    (bx0   [8][0]),
		.tmb8_lct0_syer   (syer  [8][0]),
		.tmb8_lct0_cscid  (cscid [8][0]),
		
		.tmb8_lct1_hs     (hs    [8][1]),
		.tmb8_lct1_wg     (wg    [8][1]),
		.tmb8_lct1_qual   (qual  [8][1]),
		.tmb8_lct1_cpat   (cpat  [8][1]),
		.tmb8_lct1_lr     (lr    [8][1]),
		.tmb8_lct1_vpf    (vpf   [8][1]),
		.tmb8_lct1_bc0    (bc0   [8][1]),
		.tmb8_lct1_bx0    (bx0   [8][1]),
		.tmb8_lct1_syer   (syer  [8][1]),
		.tmb8_lct1_cscid  (cscid [8][1]),
		
		.tmb9_lct0_hs     (hs    [9][0]),
		.tmb9_lct0_wg     (wg    [9][0]),
		.tmb9_lct0_qual   (qual  [9][0]),
		.tmb9_lct0_cpat   (cpat  [9][0]),
		.tmb9_lct0_lr     (lr    [9][0]),
		.tmb9_lct0_vpf    (vpf   [9][0]),
		.tmb9_lct0_bc0    (bc0   [9][0]),
		.tmb9_lct0_bx0    (bx0   [9][0]),
		.tmb9_lct0_syer   (syer  [9][0]),
		.tmb9_lct0_cscid  (cscid [9][0]),
		
		.tmb9_lct1_hs     (hs    [9][1]),
		.tmb9_lct1_wg     (wg    [9][1]),
		.tmb9_lct1_qual   (qual  [9][1]),
		.tmb9_lct1_cpat   (cpat  [9][1]),
		.tmb9_lct1_lr     (lr    [9][1]),
		.tmb9_lct1_vpf    (vpf   [9][1]),
		.tmb9_lct1_bc0    (bc0   [9][1]),
		.tmb9_lct1_bx0    (bx0   [9][1]),
		.tmb9_lct1_syer   (syer  [9][1]),
		.tmb9_lct1_cscid  (cscid [9][1]),

		.link0_tx_data (link_tx_data [0]),
		.link1_tx_data (link_tx_data [1]),
		.link2_tx_data (link_tx_data [2]),
		.link3_tx_data (link_tx_data [3]),
		.link4_tx_data (link_tx_data [4]),
		.link5_tx_data (link_tx_data [5]),
		.link6_tx_data (link_tx_data [6]),
		.link7_tx_data (link_tx_data [7]),
		
		.mpc_id (mpc_id),
	
		.clk40 (clk40)

	);

	wire [35:0] CONTROL0, CONTROL1;

	vio_control vio_c
	(
		 .CONTROL0 (CONTROL0) // INOUT BUS [35:0]
//		 .CONTROL1 (CONTROL1) // INOUT BUS [35:0]
	);

		  
	mpcx_tx_vio vio
	(
		 .CONTROL  (CONTROL0), // INOUT BUS [35:0]
		 .CLK      (clk40), // IN
		 .SYNC_OUT (enp_vio) // OUT BUS [0:0]
	);
/*
	mpcx_ila mila
	(
		 .CONTROL(CONTROL1), // INOUT BUS [35:0]
		 .CLK(clk40), // IN
		 .DATA({
				link_tx_data[7], 
				link_tx_data[6], 
				link_tx_data[5], 
				link_tx_data[4], 
				link_tx_data[3], 
				link_tx_data[2], 
				link_tx_data[1], 
				link_tx_data[0] 
			}), // IN BUS [623:0]
		 .TRIG0(link_tx_data[0][0]) // IN BUS [0:0]
	);
	*/
endmodule
