module mpcx_tx
(
	input [7:0] tmb1_lct0_hs,
	input [6:0] tmb1_lct0_wg,
	input [3:0] tmb1_lct0_qual,
	input [3:0] tmb1_lct0_cpat,
	input       tmb1_lct0_lr,
	input       tmb1_lct0_vpf,
	input       tmb1_lct0_bc0,
	input       tmb1_lct0_bx0,
	input       tmb1_lct0_syer,
	input [3:0] tmb1_lct0_cscid,

	input [7:0] tmb1_lct1_hs,
	input [6:0] tmb1_lct1_wg,
	input [3:0] tmb1_lct1_qual,
	input [3:0] tmb1_lct1_cpat,
	input       tmb1_lct1_lr,
	input       tmb1_lct1_vpf,
	input       tmb1_lct1_bc0,
	input       tmb1_lct1_bx0,
	input       tmb1_lct1_syer,
	input [3:0] tmb1_lct1_cscid,

	input [7:0] tmb2_lct0_hs,
	input [6:0] tmb2_lct0_wg,
	input [3:0] tmb2_lct0_qual,
	input [3:0] tmb2_lct0_cpat,
	input       tmb2_lct0_lr,
	input       tmb2_lct0_vpf,
	input       tmb2_lct0_bc0,
	input       tmb2_lct0_bx0,
	input       tmb2_lct0_syer,
	input [3:0] tmb2_lct0_cscid,

	input [7:0] tmb2_lct1_hs,
	input [6:0] tmb2_lct1_wg,
	input [3:0] tmb2_lct1_qual,
	input [3:0] tmb2_lct1_cpat,
	input       tmb2_lct1_lr,
	input       tmb2_lct1_vpf,
	input       tmb2_lct1_bc0,
	input       tmb2_lct1_bx0,
	input       tmb2_lct1_syer,
	input [3:0] tmb2_lct1_cscid,

	input [7:0] tmb3_lct0_hs,
	input [6:0] tmb3_lct0_wg,
	input [3:0] tmb3_lct0_qual,
	input [3:0] tmb3_lct0_cpat,
	input       tmb3_lct0_lr,
	input       tmb3_lct0_vpf,
	input       tmb3_lct0_bc0,
	input       tmb3_lct0_bx0,
	input       tmb3_lct0_syer,
	input [3:0] tmb3_lct0_cscid,

	input [7:0] tmb3_lct1_hs,
	input [6:0] tmb3_lct1_wg,
	input [3:0] tmb3_lct1_qual,
	input [3:0] tmb3_lct1_cpat,
	input       tmb3_lct1_lr,
	input       tmb3_lct1_vpf,
	input       tmb3_lct1_bc0,
	input       tmb3_lct1_bx0,
	input       tmb3_lct1_syer,
	input [3:0] tmb3_lct1_cscid,

	input [7:0] tmb4_lct0_hs,
	input [6:0] tmb4_lct0_wg,
	input [3:0] tmb4_lct0_qual,
	input [3:0] tmb4_lct0_cpat,
	input       tmb4_lct0_lr,
	input       tmb4_lct0_vpf,
	input       tmb4_lct0_bc0,
	input       tmb4_lct0_bx0,
	input       tmb4_lct0_syer,
	input [3:0] tmb4_lct0_cscid,

	input [7:0] tmb4_lct1_hs,
	input [6:0] tmb4_lct1_wg,
	input [3:0] tmb4_lct1_qual,
	input [3:0] tmb4_lct1_cpat,
	input       tmb4_lct1_lr,
	input       tmb4_lct1_vpf,
	input       tmb4_lct1_bc0,
	input       tmb4_lct1_bx0,
	input       tmb4_lct1_syer,
	input [3:0] tmb4_lct1_cscid,

	input [7:0] tmb5_lct0_hs,
	input [6:0] tmb5_lct0_wg,
	input [3:0] tmb5_lct0_qual,
	input [3:0] tmb5_lct0_cpat,
	input       tmb5_lct0_lr,
	input       tmb5_lct0_vpf,
	input       tmb5_lct0_bc0,
	input       tmb5_lct0_bx0,
	input       tmb5_lct0_syer,
	input [3:0] tmb5_lct0_cscid,

	input [7:0] tmb5_lct1_hs,
	input [6:0] tmb5_lct1_wg,
	input [3:0] tmb5_lct1_qual,
	input [3:0] tmb5_lct1_cpat,
	input       tmb5_lct1_lr,
	input       tmb5_lct1_vpf,
	input       tmb5_lct1_bc0,
	input       tmb5_lct1_bx0,
	input       tmb5_lct1_syer,
	input [3:0] tmb5_lct1_cscid,

	input [7:0] tmb6_lct0_hs,
	input [6:0] tmb6_lct0_wg,
	input [3:0] tmb6_lct0_qual,
	input [3:0] tmb6_lct0_cpat,
	input       tmb6_lct0_lr,
	input       tmb6_lct0_vpf,
	input       tmb6_lct0_bc0,
	input       tmb6_lct0_bx0,
	input       tmb6_lct0_syer,
	input [3:0] tmb6_lct0_cscid,

	input [7:0] tmb6_lct1_hs,
	input [6:0] tmb6_lct1_wg,
	input [3:0] tmb6_lct1_qual,
	input [3:0] tmb6_lct1_cpat,
	input       tmb6_lct1_lr,
	input       tmb6_lct1_vpf,
	input       tmb6_lct1_bc0,
	input       tmb6_lct1_bx0,
	input       tmb6_lct1_syer,
	input [3:0] tmb6_lct1_cscid,

	input [7:0] tmb7_lct0_hs,
	input [6:0] tmb7_lct0_wg,
	input [3:0] tmb7_lct0_qual,
	input [3:0] tmb7_lct0_cpat,
	input       tmb7_lct0_lr,
	input       tmb7_lct0_vpf,
	input       tmb7_lct0_bc0,
	input       tmb7_lct0_bx0,
	input       tmb7_lct0_syer,
	input [3:0] tmb7_lct0_cscid,

	input [7:0] tmb7_lct1_hs,
	input [6:0] tmb7_lct1_wg,
	input [3:0] tmb7_lct1_qual,
	input [3:0] tmb7_lct1_cpat,
	input       tmb7_lct1_lr,
	input       tmb7_lct1_vpf,
	input       tmb7_lct1_bc0,
	input       tmb7_lct1_bx0,
	input       tmb7_lct1_syer,
	input [3:0] tmb7_lct1_cscid,

	input [7:0] tmb8_lct0_hs,
	input [6:0] tmb8_lct0_wg,
	input [3:0] tmb8_lct0_qual,
	input [3:0] tmb8_lct0_cpat,
	input       tmb8_lct0_lr,
	input       tmb8_lct0_vpf,
	input       tmb8_lct0_bc0,
	input       tmb8_lct0_bx0,
	input       tmb8_lct0_syer,
	input [3:0] tmb8_lct0_cscid,

	input [7:0] tmb8_lct1_hs,
	input [6:0] tmb8_lct1_wg,
	input [3:0] tmb8_lct1_qual,
	input [3:0] tmb8_lct1_cpat,
	input       tmb8_lct1_lr,
	input       tmb8_lct1_vpf,
	input       tmb8_lct1_bc0,
	input       tmb8_lct1_bx0,
	input       tmb8_lct1_syer,
	input [3:0] tmb8_lct1_cscid,

	input [7:0] tmb9_lct0_hs,
	input [6:0] tmb9_lct0_wg,
	input [3:0] tmb9_lct0_qual,
	input [3:0] tmb9_lct0_cpat,
	input       tmb9_lct0_lr,
	input       tmb9_lct0_vpf,
	input       tmb9_lct0_bc0,
	input       tmb9_lct0_bx0,
	input       tmb9_lct0_syer,
	input [3:0] tmb9_lct0_cscid,

	input [7:0] tmb9_lct1_hs,
	input [6:0] tmb9_lct1_wg,
	input [3:0] tmb9_lct1_qual,
	input [3:0] tmb9_lct1_cpat,
	input       tmb9_lct1_lr,
	input       tmb9_lct1_vpf,
	input       tmb9_lct1_bc0,
	input       tmb9_lct1_bx0,
	input       tmb9_lct1_syer,
	input [3:0] tmb9_lct1_cscid,

	input [5:0] mpc_id,

    input rst,
	 input clk40,

    output [39:0] tx_data_gtp_0,
    output [39:0] tx_data_gtp_1,
    output [39:0] tx_data_gtp_2,
    output [39:0] tx_data_gtp_3,
    output [39:0] tx_data_gtp_4,
    output [39:0] tx_data_gtp_5,
    output [39:0] tx_data_gtp_6,
    output [39:0] tx_data_gtp_7,
	 input tx_clk
);

	wire [75:0] link_tx_data [7:0];
	
    (* mark_debug *) wire [37:0] tx_data_38_s [7:0], tx_data_38 [7:0];
    (* mark_debug *) wire [7:0] frame_0;
    reg  [1:0] tx_header [7:0];
    (* mark_debug *) wire [1:0] tx_header_0 = tx_header[0];
    (* mark_debug *) wire [1:0] tx_header_1 = tx_header[1];
    (* mark_debug *) wire [1:0] tx_header_2 = tx_header[2];
    (* mark_debug *) wire [1:0] tx_header_3 = tx_header[3];
    (* mark_debug *) wire [1:0] tx_header_4 = tx_header[4];
    (* mark_debug *) wire [1:0] tx_header_5 = tx_header[5];
    (* mark_debug *) wire [1:0] tx_header_6 = tx_header[6];
    (* mark_debug *) wire [1:0] tx_header_7 = tx_header[7];
    reg [5:0] tx_header_cnt [7:0];


    // transmit frame_0 marker only once per 64 BX, to prevent unlocking frame alignment in RX
    // count frame_0 markers
	 integer i;
    always @(posedge tx_clk) 
	 begin
		for (i = 0; i < 8; i=i+1)
		begin
			tx_header[i] = 
           (rst == 1'b1) ? 2'b00 : // this is for header alignment tests on rx side 
           (frame_0[i] == 1'b0 && tx_header_cnt[i] == 6'h0) ? 2'b10 : // frame_0 header
           2'b01; // regular header
			
			if (frame_0[i] == 1'b1) tx_header_cnt[i] = tx_header_cnt[i] + 6'b1;
		end
	 end
	 
 	 assign tx_data_gtp_0 = {tx_header[0], tx_data_38_s[0]};
 	 assign tx_data_gtp_1 = {tx_header[1], tx_data_38_s[1]};
 	 assign tx_data_gtp_2 = {tx_header[2], tx_data_38_s[2]};
 	 assign tx_data_gtp_3 = {tx_header[3], tx_data_38_s[3]};
 	 assign tx_data_gtp_4 = {tx_header[4], tx_data_38_s[4]};
 	 assign tx_data_gtp_5 = {tx_header[5], tx_data_38_s[5]};
 	 assign tx_data_gtp_6 = {tx_header[6], tx_data_38_s[6]};
 	 assign tx_data_gtp_7 = {tx_header[7], tx_data_38_s[7]};

	 genvar gi;
	 generate
	 for (gi = 0; gi < 8; gi=gi+1)
	 begin: link_loop


		 mpc_scrambler mpc_s 
		 (
			  .dtx (tx_data_38[gi]), // TX data to scramble
			  .stx (tx_data_38_s[gi]), // scrambled TX data
			  .clk (tx_clk),
			  .rst (1'b0)
		 );
		 
		 tx_reclock txr
		 (
			  .din     (link_tx_data [gi]),
			  .clk40   (clk40), 
			  .dout    (tx_data_38[gi]),
			  .frame_0 (frame_0[gi]),
			  .clk80   (tx_clk)
		 );
	 end
	 endgenerate
        
	mpc_formatter mpcf
	(
		.tmb1_lct0_hs (tmb1_lct0_hs),
		.tmb1_lct0_wg (tmb1_lct0_wg),
		.tmb1_lct0_qual (tmb1_lct0_qual),
		.tmb1_lct0_cpat (tmb1_lct0_cpat),
		.tmb1_lct0_lr (tmb1_lct0_lr),
		.tmb1_lct0_vpf (tmb1_lct0_vpf),
		.tmb1_lct0_bc0 (tmb1_lct0_bc0),
		.tmb1_lct0_bx0 (tmb1_lct0_bx0),
		.tmb1_lct0_syer (tmb1_lct0_syer),
		.tmb1_lct0_cscid (tmb1_lct0_cscid),

		.tmb1_lct1_hs (tmb1_lct1_hs),
		.tmb1_lct1_wg (tmb1_lct1_wg),
		.tmb1_lct1_qual (tmb1_lct1_qual),
		.tmb1_lct1_cpat (tmb1_lct1_cpat),
		.tmb1_lct1_lr (tmb1_lct1_lr),
		.tmb1_lct1_vpf (tmb1_lct1_vpf),
		.tmb1_lct1_bc0 (tmb1_lct1_bc0),
		.tmb1_lct1_bx0 (tmb1_lct1_bx0),
		.tmb1_lct1_syer (tmb1_lct1_syer),
		.tmb1_lct1_cscid (tmb1_lct1_cscid),

		.tmb2_lct0_hs (tmb2_lct0_hs),
		.tmb2_lct0_wg (tmb2_lct0_wg),
		.tmb2_lct0_qual (tmb2_lct0_qual),
		.tmb2_lct0_cpat (tmb2_lct0_cpat),
		.tmb2_lct0_lr (tmb2_lct0_lr),
		.tmb2_lct0_vpf (tmb2_lct0_vpf),
		.tmb2_lct0_bc0 (tmb2_lct0_bc0),
		.tmb2_lct0_bx0 (tmb2_lct0_bx0),
		.tmb2_lct0_syer (tmb2_lct0_syer),
		.tmb2_lct0_cscid (tmb2_lct0_cscid),

		.tmb2_lct1_hs (tmb2_lct1_hs),
		.tmb2_lct1_wg (tmb2_lct1_wg),
		.tmb2_lct1_qual (tmb2_lct1_qual),
		.tmb2_lct1_cpat (tmb2_lct1_cpat),
		.tmb2_lct1_lr (tmb2_lct1_lr),
		.tmb2_lct1_vpf (tmb2_lct1_vpf),
		.tmb2_lct1_bc0 (tmb2_lct1_bc0),
		.tmb2_lct1_bx0 (tmb2_lct1_bx0),
		.tmb2_lct1_syer (tmb2_lct1_syer),
		.tmb2_lct1_cscid (tmb2_lct1_cscid),

		.tmb3_lct0_hs (tmb3_lct0_hs),
		.tmb3_lct0_wg (tmb3_lct0_wg),
		.tmb3_lct0_qual (tmb3_lct0_qual),
		.tmb3_lct0_cpat (tmb3_lct0_cpat),
		.tmb3_lct0_lr (tmb3_lct0_lr),
		.tmb3_lct0_vpf (tmb3_lct0_vpf),
		.tmb3_lct0_bc0 (tmb3_lct0_bc0),
		.tmb3_lct0_bx0 (tmb3_lct0_bx0),
		.tmb3_lct0_syer (tmb3_lct0_syer),
		.tmb3_lct0_cscid (tmb3_lct0_cscid),

		.tmb3_lct1_hs (tmb3_lct1_hs),
		.tmb3_lct1_wg (tmb3_lct1_wg),
		.tmb3_lct1_qual (tmb3_lct1_qual),
		.tmb3_lct1_cpat (tmb3_lct1_cpat),
		.tmb3_lct1_lr (tmb3_lct1_lr),
		.tmb3_lct1_vpf (tmb3_lct1_vpf),
		.tmb3_lct1_bc0 (tmb3_lct1_bc0),
		.tmb3_lct1_bx0 (tmb3_lct1_bx0),
		.tmb3_lct1_syer (tmb3_lct1_syer),
		.tmb3_lct1_cscid (tmb3_lct1_cscid),

		.tmb4_lct0_hs (tmb4_lct0_hs),
		.tmb4_lct0_wg (tmb4_lct0_wg),
		.tmb4_lct0_qual (tmb4_lct0_qual),
		.tmb4_lct0_cpat (tmb4_lct0_cpat),
		.tmb4_lct0_lr (tmb4_lct0_lr),
		.tmb4_lct0_vpf (tmb4_lct0_vpf),
		.tmb4_lct0_bc0 (tmb4_lct0_bc0),
		.tmb4_lct0_bx0 (tmb4_lct0_bx0),
		.tmb4_lct0_syer (tmb4_lct0_syer),
		.tmb4_lct0_cscid (tmb4_lct0_cscid),

		.tmb4_lct1_hs (tmb4_lct1_hs),
		.tmb4_lct1_wg (tmb4_lct1_wg),
		.tmb4_lct1_qual (tmb4_lct1_qual),
		.tmb4_lct1_cpat (tmb4_lct1_cpat),
		.tmb4_lct1_lr (tmb4_lct1_lr),
		.tmb4_lct1_vpf (tmb4_lct1_vpf),
		.tmb4_lct1_bc0 (tmb4_lct1_bc0),
		.tmb4_lct1_bx0 (tmb4_lct1_bx0),
		.tmb4_lct1_syer (tmb4_lct1_syer),
		.tmb4_lct1_cscid (tmb4_lct1_cscid),

		.tmb5_lct0_hs (tmb5_lct0_hs),
		.tmb5_lct0_wg (tmb5_lct0_wg),
		.tmb5_lct0_qual (tmb5_lct0_qual),
		.tmb5_lct0_cpat (tmb5_lct0_cpat),
		.tmb5_lct0_lr (tmb5_lct0_lr),
		.tmb5_lct0_vpf (tmb5_lct0_vpf),
		.tmb5_lct0_bc0 (tmb5_lct0_bc0),
		.tmb5_lct0_bx0 (tmb5_lct0_bx0),
		.tmb5_lct0_syer (tmb5_lct0_syer),
		.tmb5_lct0_cscid (tmb5_lct0_cscid),

		.tmb5_lct1_hs (tmb5_lct1_hs),
		.tmb5_lct1_wg (tmb5_lct1_wg),
		.tmb5_lct1_qual (tmb5_lct1_qual),
		.tmb5_lct1_cpat (tmb5_lct1_cpat),
		.tmb5_lct1_lr (tmb5_lct1_lr),
		.tmb5_lct1_vpf (tmb5_lct1_vpf),
		.tmb5_lct1_bc0 (tmb5_lct1_bc0),
		.tmb5_lct1_bx0 (tmb5_lct1_bx0),
		.tmb5_lct1_syer (tmb5_lct1_syer),
		.tmb5_lct1_cscid (tmb5_lct1_cscid),

		.tmb6_lct0_hs (tmb6_lct0_hs),
		.tmb6_lct0_wg (tmb6_lct0_wg),
		.tmb6_lct0_qual (tmb6_lct0_qual),
		.tmb6_lct0_cpat (tmb6_lct0_cpat),
		.tmb6_lct0_lr (tmb6_lct0_lr),
		.tmb6_lct0_vpf (tmb6_lct0_vpf),
		.tmb6_lct0_bc0 (tmb6_lct0_bc0),
		.tmb6_lct0_bx0 (tmb6_lct0_bx0),
		.tmb6_lct0_syer (tmb6_lct0_syer),
		.tmb6_lct0_cscid (tmb6_lct0_cscid),

		.tmb6_lct1_hs (tmb6_lct1_hs),
		.tmb6_lct1_wg (tmb6_lct1_wg),
		.tmb6_lct1_qual (tmb6_lct1_qual),
		.tmb6_lct1_cpat (tmb6_lct1_cpat),
		.tmb6_lct1_lr (tmb6_lct1_lr),
		.tmb6_lct1_vpf (tmb6_lct1_vpf),
		.tmb6_lct1_bc0 (tmb6_lct1_bc0),
		.tmb6_lct1_bx0 (tmb6_lct1_bx0),
		.tmb6_lct1_syer (tmb6_lct1_syer),
		.tmb6_lct1_cscid (tmb6_lct1_cscid),

		.tmb7_lct0_hs (tmb7_lct0_hs),
		.tmb7_lct0_wg (tmb7_lct0_wg),
		.tmb7_lct0_qual (tmb7_lct0_qual),
		.tmb7_lct0_cpat (tmb7_lct0_cpat),
		.tmb7_lct0_lr (tmb7_lct0_lr),
		.tmb7_lct0_vpf (tmb7_lct0_vpf),
		.tmb7_lct0_bc0 (tmb7_lct0_bc0),
		.tmb7_lct0_bx0 (tmb7_lct0_bx0),
		.tmb7_lct0_syer (tmb7_lct0_syer),
		.tmb7_lct0_cscid (tmb7_lct0_cscid),

		.tmb7_lct1_hs (tmb7_lct1_hs),
		.tmb7_lct1_wg (tmb7_lct1_wg),
		.tmb7_lct1_qual (tmb7_lct1_qual),
		.tmb7_lct1_cpat (tmb7_lct1_cpat),
		.tmb7_lct1_lr (tmb7_lct1_lr),
		.tmb7_lct1_vpf (tmb7_lct1_vpf),
		.tmb7_lct1_bc0 (tmb7_lct1_bc0),
		.tmb7_lct1_bx0 (tmb7_lct1_bx0),
		.tmb7_lct1_syer (tmb7_lct1_syer),
		.tmb7_lct1_cscid (tmb7_lct1_cscid),

		.tmb8_lct0_hs (tmb8_lct0_hs),
		.tmb8_lct0_wg (tmb8_lct0_wg),
		.tmb8_lct0_qual (tmb8_lct0_qual),
		.tmb8_lct0_cpat (tmb8_lct0_cpat),
		.tmb8_lct0_lr (tmb8_lct0_lr),
		.tmb8_lct0_vpf (tmb8_lct0_vpf),
		.tmb8_lct0_bc0 (tmb8_lct0_bc0),
		.tmb8_lct0_bx0 (tmb8_lct0_bx0),
		.tmb8_lct0_syer (tmb8_lct0_syer),
		.tmb8_lct0_cscid (tmb8_lct0_cscid),

		.tmb8_lct1_hs (tmb8_lct1_hs),
		.tmb8_lct1_wg (tmb8_lct1_wg),
		.tmb8_lct1_qual (tmb8_lct1_qual),
		.tmb8_lct1_cpat (tmb8_lct1_cpat),
		.tmb8_lct1_lr (tmb8_lct1_lr),
		.tmb8_lct1_vpf (tmb8_lct1_vpf),
		.tmb8_lct1_bc0 (tmb8_lct1_bc0),
		.tmb8_lct1_bx0 (tmb8_lct1_bx0),
		.tmb8_lct1_syer (tmb8_lct1_syer),
		.tmb8_lct1_cscid (tmb8_lct1_cscid),

		.tmb9_lct0_hs (tmb9_lct0_hs),
		.tmb9_lct0_wg (tmb9_lct0_wg),
		.tmb9_lct0_qual (tmb9_lct0_qual),
		.tmb9_lct0_cpat (tmb9_lct0_cpat),
		.tmb9_lct0_lr (tmb9_lct0_lr),
		.tmb9_lct0_vpf (tmb9_lct0_vpf),
		.tmb9_lct0_bc0 (tmb9_lct0_bc0),
		.tmb9_lct0_bx0 (tmb9_lct0_bx0),
		.tmb9_lct0_syer (tmb9_lct0_syer),
		.tmb9_lct0_cscid (tmb9_lct0_cscid),

		.tmb9_lct1_hs (tmb9_lct1_hs),
		.tmb9_lct1_wg (tmb9_lct1_wg),
		.tmb9_lct1_qual (tmb9_lct1_qual),
		.tmb9_lct1_cpat (tmb9_lct1_cpat),
		.tmb9_lct1_lr (tmb9_lct1_lr),
		.tmb9_lct1_vpf (tmb9_lct1_vpf),
		.tmb9_lct1_bc0 (tmb9_lct1_bc0),
		.tmb9_lct1_bx0 (tmb9_lct1_bx0),
		.tmb9_lct1_syer (tmb9_lct1_syer),
		.tmb9_lct1_cscid (tmb9_lct1_cscid),

		.link0_tx_data (link_tx_data [0]),
		.link1_tx_data (link_tx_data [1]),
		.link2_tx_data (link_tx_data [2]),
		.link3_tx_data (link_tx_data [3]),
		.link4_tx_data (link_tx_data [4]),
		.link5_tx_data (link_tx_data [5]),
		.link6_tx_data (link_tx_data [6]),
		.link7_tx_data (link_tx_data [7]),
		
		.mpc_id (mpc_id),
	
		.clk40 (clk40)

	);
		  

endmodule
