library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity DFFSR is
    Port ( DIN : in std_logic;
	        CLK : in std_logic;
			  SET: in std_logic;
			  RES: in std_logic;
           QOUT : out std_logic);
end DFFSR;

architecture behavioral of DFFSR is

begin

process (clk, res, set) begin
   if (res = '1') then
	QOUT <= '0';
	elsif (set = '1') then
	QOUT <= '1';
	elsif (clk'event and clk = '1') then
	QOUT <= DIN;
	end if;
	end process;

end behavioral;
